<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/Surface.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_surface_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Surface.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_surface_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef _H_SURFACE_</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define _H_SURFACE_</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_material_8hpp.html">Material.hpp</a>&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_vec_8hpp.html">Vec.hpp</a>&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_transform_8hpp.html">Transform.hpp</a>&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_vertex_8hpp.html">Vertex.hpp</a>&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_ray_8hpp.html">Ray.hpp</a>&quot;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_box_8hpp.html">Box.hpp</a>&quot;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">class </span><a class="code" href="class_surface.html">Surface</a>;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="structhit__rec.html">   20</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structhit__rec.html">hit_rec</a> {</div><div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="structhit__rec.html#acf7ee9d8bc9a6080f672b55bc9fa632a">   22</a></span>&#160;    <a class="code" href="class_surface.html">Surface</a> *<a class="code" href="structhit__rec.html#acf7ee9d8bc9a6080f672b55bc9fa632a">surface</a>;</div><div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="structhit__rec.html#a974e27fdf82ec6b3678d7ab07d11c4e9">   24</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="structhit__rec.html#a974e27fdf82ec6b3678d7ab07d11c4e9">t</a>;</div><div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="structhit__rec.html#afaee7bd7656780eb7c860c69aebe3cac">   26</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="structhit__rec.html#afaee7bd7656780eb7c860c69aebe3cac">point</a>;</div><div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="structhit__rec.html#aa1bd8b2d288f749c6fc4cfc7830fa664">   28</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="structhit__rec.html#aa1bd8b2d288f749c6fc4cfc7830fa664">alpha</a>;</div><div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="structhit__rec.html#a29907e2753dc9f8a1556ca03b3eb9ba1">   30</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="structhit__rec.html#a29907e2753dc9f8a1556ca03b3eb9ba1">gamma</a>;</div><div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="structhit__rec.html#a6a31cd818d4d761a8c2f9e515c733b9e">   32</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="structhit__rec.html#a6a31cd818d4d761a8c2f9e515c733b9e">beta</a>;</div><div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="structhit__rec.html#a19e1d9c17ffdc6cd5d49e1f1caa93e3f">   34</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="structhit__rec.html#a19e1d9c17ffdc6cd5d49e1f1caa93e3f">normal</a>;</div><div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="structhit__rec.html#ac649739da1e743acb234e66146b1d3a6">   36</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="structhit__rec.html#ac649739da1e743acb234e66146b1d3a6">tex_coord</a>;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;};</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="class_surface.html">   40</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_surface.html">Surface</a> {</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="class_surface.html#a444077659d77f2e034ae163cbb103134">   45</a></span>&#160;    <a class="code" href="class_transform.html">Transform</a> *<a class="code" href="class_surface.html#a444077659d77f2e034ae163cbb103134">tf</a>;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="class_surface.html#ac8918f57a731e9f129c4a2051d0bc15d">   50</a></span>&#160;    std::vector&lt;Vertex*&gt; <a class="code" href="class_surface.html#ac8918f57a731e9f129c4a2051d0bc15d">vertexes</a>;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="class_surface.html#a60490e6d2fe723957e8814289f538624">   53</a></span>&#160;    std::string <a class="code" href="class_surface.html#a60490e6d2fe723957e8814289f538624">id</a>;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="class_surface.html#a65d1534766e141346af770b5e95503bf">   56</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_surface.html#a65d1534766e141346af770b5e95503bf">b_box_def</a>;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="class_surface.html#a99bb89c6eeea7dd90b3fda098b51422b">   59</a></span>&#160;    <a class="code" href="class_material.html">Material</a>* <a class="code" href="class_surface.html#a99bb89c6eeea7dd90b3fda098b51422b">m</a>;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="class_surface.html#aa7675dc7633490a99cd39620054e2bdb">   62</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_surface.html#aa7675dc7633490a99cd39620054e2bdb">smooth_shading</a>;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="class_surface.html#ad3cebceee209a3762a5dc2550d69064c">   65</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_surface.html#ad3cebceee209a3762a5dc2550d69064c">local_n</a>;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="class_surface.html#a7df9cc390062b02fa30e18eaea47dc3b">   68</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_surface.html#a7df9cc390062b02fa30e18eaea47dc3b">n</a>;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno"><a class="line" href="class_surface.html#a676d836b2651caf205065fcd095a356b">   71</a></span>&#160;    <a class="code" href="class_box.html">Box</a> *<a class="code" href="class_surface.html#a676d836b2651caf205065fcd095a356b">b_box</a>;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno"><a class="line" href="class_surface.html#a66c78e81a329eee37ddad0dece149b96">   75</a></span>&#160;    <a class="code" href="class_surface.html#a66c78e81a329eee37ddad0dece149b96">Surface</a>(<a class="code" href="class_material.html">Material</a> *&amp;_m) : m(_m), b_box(NULL), tf(NULL) {}</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    </div><div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="class_surface.html#a8fc57f2a15292135c00545c9d224ec68">   77</a></span>&#160;    <a class="code" href="class_surface.html#a8fc57f2a15292135c00545c9d224ec68">Surface</a>() : b_box(NULL), tf(NULL) {}</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    </div><div class="line"><a name="l00079"></a><span class="lineno"><a class="line" href="class_surface.html#a89de75c95cb550d432f3ea4ed1429db0">   79</a></span>&#160;    <a class="code" href="class_surface.html#a89de75c95cb550d432f3ea4ed1429db0">~Surface</a>() {}</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno"><a class="line" href="class_surface.html#ab59cc271b2fe0db25867fc16664cc22f">   85</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_surface.html#ab59cc271b2fe0db25867fc16664cc22f">setID</a>(std::string _id){<span class="keywordtype">id</span> = _id;};</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00091"></a><span class="lineno"><a class="line" href="class_surface.html#ab13775c761a7b51a95b57d300b94a9c8">   91</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_surface.html#ab13775c761a7b51a95b57d300b94a9c8">isSmoothShaded</a>(){<span class="keywordflow">return</span> smooth_shading;};</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    </div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno"><a class="line" href="class_surface.html#ae844c2766ec89af9dd6e65db59cf0b02">   97</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_surface.html#ae844c2766ec89af9dd6e65db59cf0b02">setSmoothShading</a>(<span class="keywordtype">bool</span> _smooth_shading){smooth_shading = _smooth_shading;};</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno"><a class="line" href="class_surface.html#ab04a7e3f5f5b51061b014bdbcfd85107">  104</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_surface.html#ab04a7e3f5f5b51061b014bdbcfd85107">getVertexPosLocalCoords</a>(<span class="keywordtype">int</span> _i) {<span class="keywordflow">return</span> vertexes[_i]-&gt;local_o;}</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    </div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="class_surface.html#a80450b9cb334e067ddaacb4380149c8e">  111</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_surface.html#a80450b9cb334e067ddaacb4380149c8e">getVertexPosWorldCoords</a>(<span class="keywordtype">int</span> _i) {<span class="keywordflow">return</span> vertexes[_i]-&gt;o;}</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    </div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00118"></a><span class="lineno"><a class="line" href="class_surface.html#a7a455dca43c650016886ea02320ed4a3">  118</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_surface.html#a7a455dca43c650016886ea02320ed4a3">setVertexPosLocalCoords</a>(<span class="keywordtype">int</span> _i, <a class="code" href="class_vec.html">Vec</a> _pos) {vertexes[_i]-&gt;local_o = _pos;}</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    </div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno"><a class="line" href="class_surface.html#a1ffcbcea002fc72862411a3edbd386a7">  124</a></span>&#160;    <a class="code" href="class_material.html">Material</a>* <a class="code" href="class_surface.html#a1ffcbcea002fc72862411a3edbd386a7">getMaterial</a>() {<span class="keywordflow">return</span> m;}</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    </div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno"><a class="line" href="class_surface.html#a2110a2eb3f0279d59a52e2034069eaae">  130</a></span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="class_surface.html#a2110a2eb3f0279d59a52e2034069eaae">setMaterial</a>(<a class="code" href="class_material.html">Material</a> *_m) {m = _m;}</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    </div><div class="line"><a name="l00133"></a><span class="lineno"><a class="line" href="class_surface.html#a1dabf409cbd72a6cf1984a21304369ff">  133</a></span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="class_surface.html#a1dabf409cbd72a6cf1984a21304369ff">bounding_box</a>() {}</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    </div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno"><a class="line" href="class_surface.html#ae3cf222676c208dc301ffc1dacb028e1">  139</a></span>&#160;    <span class="keyword">virtual</span> <a class="code" href="class_box.html">Box</a> <a class="code" href="class_surface.html#ae3cf222676c208dc301ffc1dacb028e1">getBBox</a>(){}</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    </div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;</div><div class="line"><a name="l00145"></a><span class="lineno"><a class="line" href="class_surface.html#a1b0c1c392cc14642a7ff88db7c16d0f0">  145</a></span>&#160;    <span class="keyword">virtual</span> <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_surface.html#a1b0c1c392cc14642a7ff88db7c16d0f0">getCentroid</a>(){}</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00155"></a><span class="lineno"><a class="line" href="class_surface.html#ad5b74adad1504d73dbed6e47bc011bca">  155</a></span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="class_surface.html#ad5b74adad1504d73dbed6e47bc011bca">hit</a>(<span class="keyword">const</span> <a class="code" href="class_ray.html">Ray</a> &amp;r, <a class="code" href="structhit__rec.html">hit_rec</a> &amp;h_r, <span class="keywordtype">double</span> t_min, <span class="keywordtype">double</span> t_max){}</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div><div class="line"><a name="l00161"></a><span class="lineno"><a class="line" href="class_surface.html#abcbeb2a388e4971bd7095ce57e85fb95">  161</a></span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="class_surface.html#abcbeb2a388e4971bd7095ce57e85fb95">setTransform</a>(<a class="code" href="class_transform.html">Transform</a> *_tf) {tf = _tf; transform();}</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    </div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00167"></a><span class="lineno"><a class="line" href="class_surface.html#a25a12923766c3df006fa32628fe6bd4b">  167</a></span>&#160;    <a class="code" href="class_transform.html">Transform</a>* <a class="code" href="class_surface.html#a25a12923766c3df006fa32628fe6bd4b">getTransform</a>(){<span class="keywordflow">return</span> tf;};</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> transform();</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    </div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div><div class="line"><a name="l00176"></a><span class="lineno"><a class="line" href="class_surface.html#a6eaec7d61d4a87ce7cd42089487850bf">  176</a></span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="class_surface.html#a6eaec7d61d4a87ce7cd42089487850bf">addSurfaces</a>(std::vector&lt;Surface*&gt; &amp;objects){}</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;};</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="class_surface_html_ab04a7e3f5f5b51061b014bdbcfd85107"><div class="ttname"><a href="class_surface.html#ab04a7e3f5f5b51061b014bdbcfd85107">Surface::getVertexPosLocalCoords</a></div><div class="ttdeci">Vec getVertexPosLocalCoords(int _i)</div><div class="ttdoc">Returns the position of the i-th vertex in the object frame (without being affected by any Transform)...</div><div class="ttdef"><b>Definition:</b> Surface.hpp:104</div></div>
<div class="ttc" id="structhit__rec_html_a6a31cd818d4d761a8c2f9e515c733b9e"><div class="ttname"><a href="structhit__rec.html#a6a31cd818d4d761a8c2f9e515c733b9e">hit_rec::beta</a></div><div class="ttdeci">double beta</div><div class="ttdoc">Triangle barycentric coordinate of the hit/intersection point. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:32</div></div>
<div class="ttc" id="class_surface_html_aa7675dc7633490a99cd39620054e2bdb"><div class="ttname"><a href="class_surface.html#aa7675dc7633490a99cd39620054e2bdb">Surface::smooth_shading</a></div><div class="ttdeci">bool smooth_shading</div><div class="ttdoc">Flag stating if Phong interpolation is to be used. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:62</div></div>
<div class="ttc" id="class_surface_html_a65d1534766e141346af770b5e95503bf"><div class="ttname"><a href="class_surface.html#a65d1534766e141346af770b5e95503bf">Surface::b_box_def</a></div><div class="ttdeci">bool b_box_def</div><div class="ttdoc">Flag stating if a bounding box has been defined already. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:56</div></div>
<div class="ttc" id="class_surface_html_ab59cc271b2fe0db25867fc16664cc22f"><div class="ttname"><a href="class_surface.html#ab59cc271b2fe0db25867fc16664cc22f">Surface::setID</a></div><div class="ttdeci">void setID(std::string _id)</div><div class="ttdoc">Sets a unique identifier for this Surface. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:85</div></div>
<div class="ttc" id="class_surface_html"><div class="ttname"><a href="class_surface.html">Surface</a></div><div class="ttdoc">A base class for every geometry class (e.g., Sphere, Triangle, Mesh). </div><div class="ttdef"><b>Definition:</b> Surface.hpp:40</div></div>
<div class="ttc" id="_ray_8hpp_html"><div class="ttname"><a href="_ray_8hpp.html">Ray.hpp</a></div></div>
<div class="ttc" id="class_surface_html_a7df9cc390062b02fa30e18eaea47dc3b"><div class="ttname"><a href="class_surface.html#a7df9cc390062b02fa30e18eaea47dc3b">Surface::n</a></div><div class="ttdeci">Vec n</div><div class="ttdoc">Surface&amp;#39;s associated normal in the global frame of reference - updated with transform() ...</div><div class="ttdef"><b>Definition:</b> Surface.hpp:68</div></div>
<div class="ttc" id="class_surface_html_a676d836b2651caf205065fcd095a356b"><div class="ttname"><a href="class_surface.html#a676d836b2651caf205065fcd095a356b">Surface::b_box</a></div><div class="ttdeci">Box * b_box</div><div class="ttdoc">Bounding box (a Surface itself - currently a Box) encompassing all vertexes of this surface...</div><div class="ttdef"><b>Definition:</b> Surface.hpp:71</div></div>
<div class="ttc" id="structhit__rec_html_a29907e2753dc9f8a1556ca03b3eb9ba1"><div class="ttname"><a href="structhit__rec.html#a29907e2753dc9f8a1556ca03b3eb9ba1">hit_rec::gamma</a></div><div class="ttdeci">double gamma</div><div class="ttdoc">Triangle barycentric coordinate of the hit/intersection point. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:30</div></div>
<div class="ttc" id="structhit__rec_html_aa1bd8b2d288f749c6fc4cfc7830fa664"><div class="ttname"><a href="structhit__rec.html#aa1bd8b2d288f749c6fc4cfc7830fa664">hit_rec::alpha</a></div><div class="ttdeci">double alpha</div><div class="ttdoc">Triangle barycentric coordinate of the hit/intersection point. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:28</div></div>
<div class="ttc" id="_box_8hpp_html"><div class="ttname"><a href="_box_8hpp.html">Box.hpp</a></div></div>
<div class="ttc" id="_vertex_8hpp_html"><div class="ttname"><a href="_vertex_8hpp.html">Vertex.hpp</a></div></div>
<div class="ttc" id="class_surface_html_a444077659d77f2e034ae163cbb103134"><div class="ttname"><a href="class_surface.html#a444077659d77f2e034ae163cbb103134">Surface::tf</a></div><div class="ttdeci">Transform * tf</div><div class="ttdoc">Pointer to the Transform object associated to this Surface. Set this variable with setTransform...</div><div class="ttdef"><b>Definition:</b> Surface.hpp:45</div></div>
<div class="ttc" id="structhit__rec_html_a19e1d9c17ffdc6cd5d49e1f1caa93e3f"><div class="ttname"><a href="structhit__rec.html#a19e1d9c17ffdc6cd5d49e1f1caa93e3f">hit_rec::normal</a></div><div class="ttdeci">Vec normal</div><div class="ttdoc">Surface&amp;#39;s normal at the hit/intersection point. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:34</div></div>
<div class="ttc" id="class_surface_html_ac8918f57a731e9f129c4a2051d0bc15d"><div class="ttname"><a href="class_surface.html#ac8918f57a731e9f129c4a2051d0bc15d">Surface::vertexes</a></div><div class="ttdeci">std::vector&lt; Vertex * &gt; vertexes</div><div class="ttdoc">Vector of vertexes associated to this Surface. Derived classes must use this vector if bounding boxes...</div><div class="ttdef"><b>Definition:</b> Surface.hpp:50</div></div>
<div class="ttc" id="class_surface_html_a66c78e81a329eee37ddad0dece149b96"><div class="ttname"><a href="class_surface.html#a66c78e81a329eee37ddad0dece149b96">Surface::Surface</a></div><div class="ttdeci">Surface(Material *&amp;_m)</div><div class="ttdoc">A Surface constructor. This is not supposed to be called directly by the user. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:75</div></div>
<div class="ttc" id="class_surface_html_a60490e6d2fe723957e8814289f538624"><div class="ttname"><a href="class_surface.html#a60490e6d2fe723957e8814289f538624">Surface::id</a></div><div class="ttdeci">std::string id</div><div class="ttdoc">A string containing a unique ID for the surface. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:53</div></div>
<div class="ttc" id="class_transform_html"><div class="ttname"><a href="class_transform.html">Transform</a></div><div class="ttdoc">A class to handle rigid transformations. </div><div class="ttdef"><b>Definition:</b> Transform.hpp:17</div></div>
<div class="ttc" id="class_surface_html_a2110a2eb3f0279d59a52e2034069eaae"><div class="ttname"><a href="class_surface.html#a2110a2eb3f0279d59a52e2034069eaae">Surface::setMaterial</a></div><div class="ttdeci">virtual void setMaterial(Material *_m)</div><div class="ttdoc">Sets the Material associated to this Surface (via a pointer). </div><div class="ttdef"><b>Definition:</b> Surface.hpp:130</div></div>
<div class="ttc" id="class_surface_html_a7a455dca43c650016886ea02320ed4a3"><div class="ttname"><a href="class_surface.html#a7a455dca43c650016886ea02320ed4a3">Surface::setVertexPosLocalCoords</a></div><div class="ttdeci">void setVertexPosLocalCoords(int _i, Vec _pos)</div><div class="ttdoc">Sets the position of the i-th vertex in the object frame (without being affected by any Transform)...</div><div class="ttdef"><b>Definition:</b> Surface.hpp:118</div></div>
<div class="ttc" id="structhit__rec_html_acf7ee9d8bc9a6080f672b55bc9fa632a"><div class="ttname"><a href="structhit__rec.html#acf7ee9d8bc9a6080f672b55bc9fa632a">hit_rec::surface</a></div><div class="ttdeci">Surface * surface</div><div class="ttdoc">Pointer to the Surface hit by the Ray. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:22</div></div>
<div class="ttc" id="class_surface_html_a1dabf409cbd72a6cf1984a21304369ff"><div class="ttname"><a href="class_surface.html#a1dabf409cbd72a6cf1984a21304369ff">Surface::bounding_box</a></div><div class="ttdeci">virtual void bounding_box()</div><div class="ttdoc">Computes an Axis-Aligned Bounding Box that encompasses all vertexes of this Surface. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:133</div></div>
<div class="ttc" id="class_material_html"><div class="ttname"><a href="class_material.html">Material</a></div><div class="ttdoc">A class to create and manipulate surface materials. </div><div class="ttdef"><b>Definition:</b> Material.hpp:19</div></div>
<div class="ttc" id="class_surface_html_ae3cf222676c208dc301ffc1dacb028e1"><div class="ttname"><a href="class_surface.html#ae3cf222676c208dc301ffc1dacb028e1">Surface::getBBox</a></div><div class="ttdeci">virtual Box getBBox()</div><div class="ttdoc">Returns the bounding box of this surface. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:139</div></div>
<div class="ttc" id="class_surface_html_a1b0c1c392cc14642a7ff88db7c16d0f0"><div class="ttname"><a href="class_surface.html#a1b0c1c392cc14642a7ff88db7c16d0f0">Surface::getCentroid</a></div><div class="ttdeci">virtual Vec getCentroid()</div><div class="ttdoc">Returns the centroid of this surface. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:145</div></div>
<div class="ttc" id="class_surface_html_a89de75c95cb550d432f3ea4ed1429db0"><div class="ttname"><a href="class_surface.html#a89de75c95cb550d432f3ea4ed1429db0">Surface::~Surface</a></div><div class="ttdeci">~Surface()</div><div class="ttdef"><b>Definition:</b> Surface.hpp:79</div></div>
<div class="ttc" id="class_surface_html_a1ffcbcea002fc72862411a3edbd386a7"><div class="ttname"><a href="class_surface.html#a1ffcbcea002fc72862411a3edbd386a7">Surface::getMaterial</a></div><div class="ttdeci">Material * getMaterial()</div><div class="ttdoc">Returns a pointer to the Material associated to this Surface. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:124</div></div>
<div class="ttc" id="class_surface_html_a99bb89c6eeea7dd90b3fda098b51422b"><div class="ttname"><a href="class_surface.html#a99bb89c6eeea7dd90b3fda098b51422b">Surface::m</a></div><div class="ttdeci">Material * m</div><div class="ttdoc">Material associated to this surface. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:59</div></div>
<div class="ttc" id="class_surface_html_ad5b74adad1504d73dbed6e47bc011bca"><div class="ttname"><a href="class_surface.html#ad5b74adad1504d73dbed6e47bc011bca">Surface::hit</a></div><div class="ttdeci">virtual bool hit(const Ray &amp;r, hit_rec &amp;h_r, double t_min, double t_max)</div><div class="ttdef"><b>Definition:</b> Surface.hpp:155</div></div>
<div class="ttc" id="class_surface_html_a25a12923766c3df006fa32628fe6bd4b"><div class="ttname"><a href="class_surface.html#a25a12923766c3df006fa32628fe6bd4b">Surface::getTransform</a></div><div class="ttdeci">Transform * getTransform()</div><div class="ttdoc">Returns a pointer to the Transform node associated with this Surface through method setTransform...</div><div class="ttdef"><b>Definition:</b> Surface.hpp:167</div></div>
<div class="ttc" id="_transform_8hpp_html"><div class="ttname"><a href="_transform_8hpp.html">Transform.hpp</a></div></div>
<div class="ttc" id="class_vec_html"><div class="ttname"><a href="class_vec.html">Vec</a></div><div class="ttdoc">A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:16</div></div>
<div class="ttc" id="class_surface_html_ad3cebceee209a3762a5dc2550d69064c"><div class="ttname"><a href="class_surface.html#ad3cebceee209a3762a5dc2550d69064c">Surface::local_n</a></div><div class="ttdeci">Vec local_n</div><div class="ttdoc">Surface&amp;#39;s associated normal in the local frame of reference (computed elsewhere) </div><div class="ttdef"><b>Definition:</b> Surface.hpp:65</div></div>
<div class="ttc" id="class_surface_html_a6eaec7d61d4a87ce7cd42089487850bf"><div class="ttname"><a href="class_surface.html#a6eaec7d61d4a87ce7cd42089487850bf">Surface::addSurfaces</a></div><div class="ttdeci">virtual void addSurfaces(std::vector&lt; Surface *&gt; &amp;objects)</div><div class="ttdoc">Adds this surface (its pointer, actually) to a given vector of surfaces. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:176</div></div>
<div class="ttc" id="structhit__rec_html_ac649739da1e743acb234e66146b1d3a6"><div class="ttname"><a href="structhit__rec.html#ac649739da1e743acb234e66146b1d3a6">hit_rec::tex_coord</a></div><div class="ttdeci">Vec tex_coord</div><div class="ttdoc">Texture coordinate of the hit/intersection point. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:36</div></div>
<div class="ttc" id="class_surface_html_ae844c2766ec89af9dd6e65db59cf0b02"><div class="ttname"><a href="class_surface.html#ae844c2766ec89af9dd6e65db59cf0b02">Surface::setSmoothShading</a></div><div class="ttdeci">void setSmoothShading(bool _smooth_shading)</div><div class="ttdoc">Sets a boolean stating whether this surface should be renderered with smooth shading. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:97</div></div>
<div class="ttc" id="_material_8hpp_html"><div class="ttname"><a href="_material_8hpp.html">Material.hpp</a></div></div>
<div class="ttc" id="_vec_8hpp_html"><div class="ttname"><a href="_vec_8hpp.html">Vec.hpp</a></div></div>
<div class="ttc" id="structhit__rec_html_afaee7bd7656780eb7c860c69aebe3cac"><div class="ttname"><a href="structhit__rec.html#afaee7bd7656780eb7c860c69aebe3cac">hit_rec::point</a></div><div class="ttdeci">Vec point</div><div class="ttdoc">Hit/intersection point. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:26</div></div>
<div class="ttc" id="class_surface_html_a8fc57f2a15292135c00545c9d224ec68"><div class="ttname"><a href="class_surface.html#a8fc57f2a15292135c00545c9d224ec68">Surface::Surface</a></div><div class="ttdeci">Surface()</div><div class="ttdef"><b>Definition:</b> Surface.hpp:77</div></div>
<div class="ttc" id="class_surface_html_a80450b9cb334e067ddaacb4380149c8e"><div class="ttname"><a href="class_surface.html#a80450b9cb334e067ddaacb4380149c8e">Surface::getVertexPosWorldCoords</a></div><div class="ttdeci">Vec getVertexPosWorldCoords(int _i)</div><div class="ttdoc">Returns the position of the i-th vertex in the world frame (after being affected by the Transform hie...</div><div class="ttdef"><b>Definition:</b> Surface.hpp:111</div></div>
<div class="ttc" id="class_surface_html_abcbeb2a388e4971bd7095ce57e85fb95"><div class="ttname"><a href="class_surface.html#abcbeb2a388e4971bd7095ce57e85fb95">Surface::setTransform</a></div><div class="ttdeci">virtual void setTransform(Transform *_tf)</div><div class="ttdoc">Associates a Transform node to this Surface. The method transform() can then be used to change the Su...</div><div class="ttdef"><b>Definition:</b> Surface.hpp:161</div></div>
<div class="ttc" id="class_box_html"><div class="ttname"><a href="class_box.html">Box</a></div><div class="ttdef"><b>Definition:</b> Box.hpp:12</div></div>
<div class="ttc" id="structhit__rec_html_a974e27fdf82ec6b3678d7ab07d11c4e9"><div class="ttname"><a href="structhit__rec.html#a974e27fdf82ec6b3678d7ab07d11c4e9">hit_rec::t</a></div><div class="ttdeci">double t</div><div class="ttdoc">Scalar to generate the hit/intersection point from the ray equation o+td. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:24</div></div>
<div class="ttc" id="class_ray_html"><div class="ttname"><a href="class_ray.html">Ray</a></div><div class="ttdoc">A class to create and manipulate 3D rays. </div><div class="ttdef"><b>Definition:</b> Ray.hpp:12</div></div>
<div class="ttc" id="structhit__rec_html"><div class="ttname"><a href="structhit__rec.html">hit_rec</a></div><div class="ttdoc">A structure used to hold information regarding ray-surface intersection events. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:20</div></div>
<div class="ttc" id="class_surface_html_ab13775c761a7b51a95b57d300b94a9c8"><div class="ttname"><a href="class_surface.html#ab13775c761a7b51a95b57d300b94a9c8">Surface::isSmoothShaded</a></div><div class="ttdeci">bool isSmoothShaded()</div><div class="ttdoc">Returns a boolean stating whether this surface should be renderered with smooth shading. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:91</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_surface_8hpp.html">Surface.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
